#pragma once

/* Checkweigher library by alelondono@genial.io
 */

// This will load the definition for common Particle variable types
#include "Particle.h"

// This is your main class that users will import into their application
class Checkweigher
{
  public:
    //variables
    byte index = 0;
    char receivedChars[64];
    byte numChars = 13; //longitud caracteres por linea
    byte dataLength = 5; //cuantos caracteres tiene la lectura de peso
    byte dataIndex = 6; //indice posicion primer caracter de la lectura de peso
    byte referLength = 5; //cuantos caracteres tiene la lectura de referencia
    byte referIndex = 6;    //indice posicion primer caracter de la lectura de referencia
    boolean refer_enable = true;
    boolean newData = false;
    unsigned long checkweigher_timestamp; 

    byte bufferSize = 6;
    byte bufferIndex = 0;
    char data[512] = "{";

    byte norm_cont_contkey = 0; //norm: un dato por lectura, cont:constantemente mandando, contkey:constantemente mandando pero key que indica estable
    //boolean perman_enable = true;
    char stable_key[2] = {'S','\0'};
    boolean streak_reached = false;
    int current_streak = 0;
    float current_streak_weight = 0.0;
    float min_weight = 1.0;

    //functions
    Checkweigher();
    void begin();
    void process();
    bool compare_float(float x, float y, float epsilon = 0.01f);
    void setIndexes(byte _numChars, byte _dataLength, byte _dataIndex, byte _referLength, byte _referIndex, boolean _refer_enable, byte _norm_cont_contkey, float _min_weight, char _key);
    void recvWithEndMarker();
    void recvWithStartMarker();
    void showNewData();
    void publish(char _buffer[], char _refer[]);

  private:
    void doit();
};
